{"changed":false,"filter":false,"title":"expand.js","tooltip":"/src/expand.js","value":"import React from \"react\";\n\nconst asArray = x => Array.isArray( x ) ? x : [].concat( x || [] );\n\nconst asItems = is => asArray( is )\n    .map( i => typeof i === \"object\" ? i : { \"prop\": i } )\n    .map( i => \"key\" in i ? i : { ...i, key: i.prop } )\n    .map( i => \"className\" in i ? i : { ...i, className: i.prop || i.key } )\n    .map( i => \"items\" in i ? { ...i, items: asItems( i.items ) } : i );\n\nconst expandClassNameBit = ( classNameBit, ti, d ) => {\n    \n    switch( classNameBit ) {\n        \n        case \"{prop}\":\n            return ti.prop;\n        case \"{key}\":\n            return ti.key;\n        case \"{truthiness}\":\n            return ( !!d[ ti.prop ] ).toString();\n        default:\n            return classNameBit;\n            \n    }\n    \n};\n\nconst expandClassName = ( className, ti, d ) => className\n    .split( \" \" )\n    .map( c => expandClassNameBit( c, ti, d ) )\n    .join( \" \" );\n    \nconst classNameOf = ( ti, d ) => ti.className\n    ? expandClassName( ti.className, ti, d )\n    : ti.propName;\n\nconst keyOf = ( ti, d ) => ti.keyProp\n    ? d[ ti.keyProp ]\n    : ti.key;\n    \nconst element = ( ti, d, content ) => \n    ti.div \n        ? <div key={ keyOf( ti, d ) } className={ classNameOf( ti, d ) }>{content}</div> \n        : <span key={ keyOf( ti, d ) } className={ classNameOf( ti, d ) }>{content}</span>;\n\nconst dangerouslyUpdateObject =\n\n    ( d, ti ) =>\n    \n        e =>\n            \n            d[ ti.prop ] = e.target.value;\n        \nconst controlElement =\n\n    ( ti, d, editable ) => {\n        \n        const editableType = ti.editable.type;\n        switch( editableType ) {\n            \n            case \"textarea\":\n                return <textarea name={ ti.prop } value={ d[ ti.prop ] } onChange={ dangerouslyUpdateObject( d, ti ) } />;\n            case \"numeric\":\n                return <input type=\"number\" name={ ti.prop } value={ d[ ti.prop ] || \"\" } onChange={ dangerouslyUpdateObject( d, ti ) } />;\n            default:\n                return <input type=\"text\" name={ ti.prop } value={ d[ ti.prop ] || \"\" } onChange={ dangerouslyUpdateObject( d, ti ) } />;\n                \n        }    \n        \n    };\n\n            \nconst control =\n    \n    ( ti, d, editable ) =>\n        \n        <label>\n        \n            <span>{ ti.editable.label }</span>\n            { controlElement( ti, d, editable ) }\n                 \n        </label>;\n    \nconst contentOf = ( ti, d, editable ) => \"items\" in ti\n    ? ti.items.map( tii => element( tii, d, contentOf( tii, d, editable ), editable ) )\n    : ( editable && ti.editable )\n        ? control( ti, d, editable )\n        : d\n            ? d[ ti.prop ] \n            : null;\n    \nconst contentsOf = ( ti, d, editable ) => Array.isArray( d[ ti.prop ] )\n    ? <ul>{d[ ti.prop ].map( ( di, diIndex ) => \n \n        <li key={ keyOf( ti, di ) }>{contentOf( ti, di, editable )}</li>\n    \n    )}</ul>\n    : contentOf( ti, d, editable );\n\nexport default function expand( template, data, editable = false ) {\n \n    return asItems( template )\n        .map( templateItem => element( \n            \n            templateItem, \n            data, \n            contentsOf( templateItem, data, editable )\n\n        ) );\n    \n}\n","undoManager":{"mark":-1,"position":-1,"stack":[]},"ace":{"folds":[],"scrolltop":912,"scrollleft":0,"selection":{"start":{"row":62,"column":18},"end":{"row":62,"column":25},"isBackwards":false},"options":{"guessTabSize":true,"useWrapMode":false,"wrapToView":true},"firstLineState":{"row":56,"state":"start","mode":"ace/mode/javascript"}},"timestamp":1536957487720}